		EVEN

WWDNL		proc	near	; zapis do downloadu

		pop	bx
		mov     es:[bp - 7000h], bx
		ret

WWDNL		endp

		EVEN

RWDNL		proc	near	; cteni z downloadu

		pop	bx
		mov	bx, es:[bp - 7000h]
		ret

RWDNL		endp

		EVEN

WB7VRAM		proc	near	; zapis do MZ-700 VRAM

		pop	bx
WB7VRAMC:	mov	es:[bp - 9000h], bl	; na 4000h
		test	bp, 400h		; nastaven ?
		jz	WB7VRAM_1		; nekoncim
		ret
WB7VRAM_1:	mov	ds, cs:seg_VRAM
		pusha
		and	bp, 3ffh		; pozice znaku a atributu
		mov	bh, 0
		mov	bl, es:[bp + 4000h]	; vezmi znak
		mov	si, bx
		mov	bl, es:[bp + 4800h]	; vezmi atribut
		test	bl, 80h			; druha sada ?
		jz	WB7VRAM_2		; ne
		and	bl, 7fh
		add	si, 100h		; nastav na druhou sadu
WB7VRAM_2:	add	bx, bx
		mov	cx, es:[bx + 6800h]	; prevodni tabulka atributu
		add	bp, bp
		mov	bp, es:[bp + 6000h]	; prevodni tabulka adres
		shl	si, 3			; * 8
		add	si, 5000h		; download
		mov	dx, 3ceh
		mov	di, cx
		mov	bx, 7000h		; 256 pro prevod bitu

		irp	X, <0, 40, 80, 120, 160, 200, 240, 280>

		mov	al, es:[si]
		db	26h			; es:
		xlat
		mov	ah, al
		mov	al, 8
		out	dx, ax
		xchg	ds:[bp + X], ch
		not	ah
		out	dx, ax
		xchg	ds:[bp + X], cl
		mov	cx, di
		inc	si

		endm

		popa
		mov	ds, cs:seg_RAM
		ret

WB7VRAM		endp

		EVEN

RB7VRAM		proc	near

		pop	bx
		mov	bl, es:[bp - 9000h]
		ret

RB7VRAM		endp

		EVEN

WW7VRAM		proc	near

		pop	bx
		call	WB7VRAM		; zapis 1 byte
		push	bx
		mov	bl, ah
		inc	bp
		call	WB7VRAM		; zapis 2 byte
		dec	bp
		pop	bx
		ret

WW7VRAM		endp

		EVEN

RW7VRAM		proc	near

		pop	bx
		mov	bx, es:[bp - 9000h]
		ret

RW7VRAM		endp

		EVEN

prepareVGA	proc	near

		mov	cs:seg_VRAM, 0a000h
		cmp	cs:MODE, 0ffh		; MZ - 800 mod ?
		jz	prepareVGA_800
		mov	ax, 0dh			; 320 x 200 16 color
		int	10h
		mov	dx, 3ceh		; nastav mod cislo 2
		mov	ax, 205h
		out	dx, ax
		mov	ax, 0003h
		out	dx, ax
		mov	ax, 0ff01h
		out	dx, ax
		mov	ax, 0f00h
		out	dx, ax
		mov	es, cs:seg_ROM
		mov	bp, 0d000h		; VRAM u sharpa
		mov	si, 4000h		; VRAM sharpa
		mov	cx, 400h
prepareVGA_0:	mov	bl, es:[si]
		call	WB7VRAMC			; zapis
		inc	bp
		inc	si
		loop	prepareVGA_0
prepareVGA_800:	ret

prepareVGA	endp

