; ==================================
;
;          EMULACE I8255
;
; ==================================

		EVEN

C8255		db	0

		EVEN

SNDON		db	0ffh		; on ...

		EVEN

tbl8bits        db	1, 2, 4, 8, 10h, 20h, 40h, 80h

		EVEN

w8255		proc	near

		pop	bx
		mov     bh, bl
		jmp	out_8255_s

w8255		endp

		EVEN

out_8255	proc	near

		pop	bx
out_8255_s:     test	bh, 80h		; nastaveni brany C ?
		jnz	@@k
		push	ax
		mov	al, bh
		mov	bl, bh
		shr	bl, 1
		and	bx, 7
		mov	bl, cs:[bx + offset tbl8bits]
		test	al, 1
		jnz	@@1
		not	bl
		and	cs:C8255, bl
		jmp	@@2
@@1:		or	cs:C8255, bl
@@2:		mov	ah, 3
		test	cs:C8255, 1
		jnz	@@3
		mov	ah, 0
@@3:		cmp	cs:mzakt, 0ffh
		jz	@@mzm
		in	al, 61h
		and	al, 0fch
		and	ah, cs: SNDON
		or	al, ah
		out	61h, al
		pop	ax
@@k:		ret
@@mzm:		test	ah, 1
		mov	ah, 40h
		jnz	@@mzm1
		mov	ah, 0
@@mzm1:         mov	cs:[ offset MZGEN4 + 8 ], ah
		pop	ax
		ret

out_8255	endp

		EVEN

w8255C		proc	near

		pop	bx
		mov	bh, bl
		jmp	out_8255C_1

w8255C		endp

		EVEN

out_8255C	proc	near

		pop	bx
out_8255C_1:    mov	cs:C8255, bh
		push	ax
		cmp	cs:cntmode, 2
		jz	@@01
		cmp	cs:cntmode, 3
		jz	@@01
		jmp	@@02
@@01:		mov	ah, 3
		test	bh, 1
		jnz	@@1
@@02:		mov	ah, 0
@@1:		cmp	cs: mzakt, 0ffh
		jz	@@mzm
		in	al, 61h
		and	al, 0fch
		and	ah, cs:SNDON
		or	al, ah
		out	61h, al
		mov	cs:spkoff, 0
		pop	ax
		ret
@@mzm:		test	ah, 1
		mov	ah, 40h
		jnz	@@mzm1
		mov	ah, 0
@@mzm1:         mov	cs:[ offset MZGEN4 + 8 ], ah
		pop	ax
		ret

out_8255C	endp

		EVEN

inp_8255C	proc	near

		push	dx
		push	ax
		mov	dx, 3dah
		in	al, dx
		shl	al, 4
		mov	bl, al
		and	bl, 80h
		mov	al, cs:crs_blk
		and	al, 01010000b		; motor taky ...
		or	bl, al
		mov	al, cs:C8255
		and	al, 0fh
		or	bl, al
		pop	ax
		pop	dx
		ret

inp_8255C	endp
