; ==========================================
;
;           EMULACE obvodu 8253
;
; ==========================================

		EVEN
cntmode		db	0, 0, 0		; mod vsech citacu
		EVEN
cntwr		db	0, 0, 0		; zpusob cteni a zapisu
		EVEN
_ctcs		db	0, 0, 0		; 0ffh po precteni nebo zapsani
		EVEN                    ; prvniho slova
_ctc		dw	0, 0, 0		; vyrovnavaci registry pro cteni za
					; letu
		EVEN
_ctcset		dw	0, 0, 0		; hodnoty citacu
_ctcakt		dw	0, 0, 0		; take nastavit !!!
		EVEN
cnt2intr	dw	0


out_wcmd8253	proc	near

		pop	bx
		push	bx
		push	ax
		mov	bl, bh
		jmp	wcmd8253_s

out_wcmd8253	endp

		EVEN

wcmd8253	proc	near

		pop	bx
		push	bx
		push	ax
wcmd8253_s:	mov	al, bl
		rol	bl, 2		; cislo citace na 0. a 1. bit
		and	bx, 3		; orizni ho
		mov	ah, al
		shr	ah, 1
		and	ah, 7
		cmp	bl, 0		; nulty citac ?
		jnz	@@1
		cmp	ah, 2
		jz	@@1
		cmp	ah, 3
		jz	@@1
		push	ax
		cmp	cs:mzakt, 0ffh
		jz	@@mzm
		in	al, 61h		; vypni speaker
		and	al, 0fch
		out	61h, al
@@mzm:		pop	ax
@@1:		mov	cs:[bx + offset cntmode], ah
		mov	ah, al
		shr	ah, 4
		and	ah, 3
		mov	cs:[bx + offset cntwr], ah
		mov	byte ptr cs:[bx + offset _ctcs], 0
		test	al, 1		; BCD ?
		jz	wcmd8253_1
wcmd8253_x:	pop	ax		; vem AF
		mov	bx, 2		; chybne nastaveni
		jmp	error
wcmd8253_1:	pop	ax
		pop	bx
		ret

wcmd8253	endp

		EVEN

rcmd8253	proc	near

		mov	bl, 0
		ret

rcmd8253	endp

		EVEN

out_wctc0	proc	near

		pop	bx
		mov	bl, bh
		jmp	wctc0_s

out_wctc0	endp

		EVEN

wctc0		proc	near

		pop	bx
wctc0_s:	cmp     cs:cntwr, 3	; cti a zapis oba bity ?
		jz	wctc0_z
		cmp	cs:cntwr, 0
		jz	wctc0_z
		mov	bx, 4
		jmp	error
wctc0_z:	cmp     _ctcs, 0ffh	; druhe slovo ?
		jz	wctc0_1		; ano ...
		mov     byte ptr cs:[_ctcset], bl
		mov	_ctcs, 0ffh
		ret
wctc0_1:	mov	byte ptr cs:[_ctcset + 1], bl
		mov	_ctcs, 0
		push	ax
		cli
		cmp	cs: mzakt, 0ffh
		jz	@@1
		mov	al, 0b4h	; generator frekvenci
		out	43h, al
		mov	ax, cs:_ctcset
		out	42h, al
		mov	al, ah
		out	42h, al
@@1:		sti
		pop	ax
		ret

wctc0		endp

		EVEN

out_wctc1	proc	near

		pop	bx
		mov	bl, bh
		jmp	wctc1_s

out_wctc1	endp

		EVEN

wctc1		proc	near

		pop	bx
wctc1_s:	cmp	byte ptr cs:cntwr + 1, 3	; cti a zapis oba bity ?
		jz      wctc1_z
		cmp	byte ptr cs:cntwr + 1, 0
		jz	wctc1_z
		mov	bx, 4
		jmp	error
wctc1_z:	cmp     _ctcs + 1, 0ffh	; druhe slovo ?
		jz	wctc1_1		; ano ...
		mov     byte ptr cs:[_ctcset + 2], bl
		mov	_ctcs + 1, 0ffh
		ret
wctc1_1:	mov	byte ptr cs:[_ctcset + 3], bl
		mov	_ctcs + 1, 0
		push	ax
		mov	ax, cs:_ctcset + 2
		mov	cs:_ctcakt + 2, ax
		pop	ax
		ret

wctc1		endp

		EVEN

out_wctc2	proc	near

		pop	bx
		mov	bl, bh
		jmp	wctc2_s

out_wctc2	endp

wctc2		proc	near

		pop	bx
wctc2_s:	cmp	byte ptr cs:cntwr + 2, 3
		jz      wctc2_z
		cmp	byte ptr cs:cntwr + 2, 0
		jz	wctc2_z
		mov	bx, 4
		jmp	error
wctc2_z:	cmp     _ctcs + 2, 0ffh	; druhe slovo ?
		jz	wctc2_1		; ano ...
		mov     byte ptr cs:[_ctcset + 4], bl
		mov	_ctcs + 2, 0ffh
		ret
wctc2_1:	mov	byte ptr cs:[_ctcset + 5], bl
		mov	_ctcs + 2, 0
		push	ax
		mov	ax, _ctcset + 4
		mov	cs:_ctcakt + 4, ax
		pop	ax
		ret

wctc2		endp

; =================================================
;
;  Pro vsechny je aplikovano pouze cteni za letu
;
; =================================================

rctc0		proc	near

		cmp	cs:cntwr, 0	; cteni za letu ?
		jz	rctc0_z
		cmp	cs:cntwr, 3
		jz	rctc0_z
		mov	bx, 4		; umim jenom cteni za letu ...
		jmp	error
rctc0_z:	cmp	cs:_ctcs, 0ffh	; druhe slovo ?
		jz	rctc0_z1	; ano ...
		push	ax
		in	al, 42h
		mov	ah, al
		in	al, 42h
		xchg	ah, al
		mov	cs:_ctc, ax	; vyrovnavaci registr
		mov	bl, al
		pop	ax
		mov	cs:_ctcs, 0ffh	; druhe slovo ...
		ret
rctc0_z1:	mov	bl, byte ptr cs:_ctc + 1
		mov	cs:_ctcs, 0
		ret

rctc0		endp

rctc1		proc	near

		cmp	cs:cntwr + 1, 0	; cteni za letu ?
		jz	rctc1_z
		cmp	cs:cntwr + 1, 3
		jz	rctc1_z
		mov	bx, 4		; umim jenom cteni za letu ...
		jmp	error
rctc1_z:	cmp	cs:_ctcs + 1, 0ffh	; druhe slovo ?
		jz	rctc1_z1	; ano ...
		push	ax
		mov	ax, cs:_ctcakt + 2
		mov	cs:_ctc + 2, ax	; vyrovnavaci registr
		mov	bl, al
		pop	ax
		mov	cs:_ctcs + 1, 0ffh	; druhe slovo ...
		ret
rctc1_z1:	mov	bl, byte ptr cs:_ctc + 3
		mov	cs:_ctcs + 1, 0
		ret

rctc1		endp

rctc2		proc	near

		cmp	cs:cntwr + 2, 0	; cteni za letu ?
		jz	rctc2_z
		cmp	cs:cntwr + 2, 3
		jz	rctc2_z
		mov	bx, 4		; umim jenom cteni za letu ...
		jmp	error
rctc2_z:	cmp	cs:_ctcs + 2, 0ffh	; druhe slovo ?
		jz	rctc2_z1	; ano ...
		push	ax
		mov	ax, cs:_ctcakt + 4
		mov	cs:_ctc + 4, ax	; vyrovnavaci registr
		mov	bl, al
		pop	ax
		mov	cs:_ctcs + 2, 0ffh	; druhe slovo ...
		ret
rctc2_z1:	mov	bl, byte ptr cs:_ctc + 5
		mov	cs:_ctcs + 2, 0
		ret

rctc2		endp

; =================================

		EVEN

counters	proc	near

		mov	cs: cnt2intr, 0
		cmp	word ptr cs: cntmode + 1, 2		; stejne
		jz	@@01
		cmp	word ptr cs: cntmode + 1, 6		; stejne
		jnz	@@1
@@01:		sub	cs: _ctcakt + 2, 78
		jnc	@@1
		push	ax
		mov	ax, cs:_ctcset + 2
@@02:		add	cs: _ctcakt + 2, ax
		jns	@@2
		dec	cs:_ctcakt + 4
		cmp	cs:_ctcakt + 4, 0ffffh
		jnz	@@02
		pop	ax
		jmp	@@3
@@2:		pop	ax
		dec	cs:_ctcakt + 4
		cmp	cs:_ctcakt + 4, 0ffffh
		jnz	@@1
@@3:		mov	cs: cnt2intr, 0ffh
@@1:		ret

counters	endp

		EVEN

motoroff	proc	near

		push	ax
		push	dx
		mov	dx, 3f2h
		in	al, dx
		and	al, 0fh
		out	dx, al
		pop	dx
		push	es
		xor	ax, ax
		mov	es, ax
		mov	byte ptr es:[43fh], 0
		pop	es
		pop	ax
		ret

motoroff	endp

		EVEN

cnt_crs		db	5
		EVEN
crs_blk		db	0
		EVEN
cnt_33		db	6
		EVEN
frekv_33	db	0
		EVEN
jednou4		db	0
		EVEN
spkoff		db	0
		EVEN
frekvmotor	dw	1000
		EVEN

		EVEN

main_8_r	proc	near
		public	main_8_r

		cmp	cs:frekvmotor, 0
		jz	@@m1
		dec	cs:frekvmotor
		jnz	@@m1
		call	motoroff
@@m1:		dec	cs:cnt_33
		jnz	@@01x1
		mov	cs:cnt_33, 6
		not	cs:frekv_33
@@01x1:         call	counters
		cmp	cs:intr_imx, 1
		jnz	@@01
		cmp	cs: cnt2intr, 0ffh
		jnz	@@01
		jmp	@@im1
@@01:		dec	cs:jednou4
		and	cs:jednou4, 3
		jz	@@001
		ret
@@001:		cmp	cs:intr_in, 0ffh	; jsem v prerus ?
		jz      @@1			; ano ... kasli na to ..
		cmp	cs:intr_poz, 0
		jnz	@@1
		cmp	cs:intr_off, 0ffh	; zakazano ?
		jz	@@1
		cmp	cs:intr_go, 0ffh	; aktivovano ?
		jnz	@@1
		cmp	cs:intr_imx, 2
		jnz	@@1
@@in:		mov	cs:intr_poz, 0ffh
		push	ax
		push	cx
		push	di
		push	es
		mov	ax, cs
		mov	es, ax
		mov	cx, 256
		mov	ax, offset intr_rut	; v souboru PIO.ASM
		mov	di, offset one_byte
		cld
		rep stosw			; ok, vse je pripraveno ...
		pop	es
		pop	di
		pop	cx
		pop	ax
@@1:		push	ax
		dec	cs:cnt_crs
		jnz	@@3
		mov	cs:cnt_crs, 25
		not	cs:crs_blk
@@3:		cmp	cs:i_play, 0
		jnz	@@spk1
		cmp	cs:mzakt, 0ffh
		jz	@@mzm
		in	al, 61h
		and	al, 0fch
		out	61h, al
@@spk1:		pop	ax
		ret
@@mzm:		mov	byte ptr cs:[offset MZGEN4 + 8], 0
		pop	ax
		ret
@@im1:		test	cs:C8255, 4
		jz	@@1
		jmp	@@in

main_8_r	endp

		EVEN

main_8		proc

		call	main_8_r
		push	ax
		mov	al, 20h
		out	20h, al
		pop	ax
		iret

main_8		endp

old_8		dw	0, 0

sch_21		db	0

; =================================

store8253	proc	near
		public	store8253

		call	tdone
		push	ax
		mov	al, 34h
		out	43h, al
		mov	ax, 0
		out	40h, al
		mov	al, ah
		out	40h, al
		mov	al, 0b6h
		out	43h, al
		mov	ax, 1b8h
		out	42h, al
		mov	al, ah
		out	42h, al
		push	ds
		xor	ax, ax
		mov	ds, ax
		cli
		mov	ax, cs:old_8
		mov	ds:[8 * 4], ax
		mov	ax, cs:old_8 + 2
		mov	ds:[8 * 4 + 2], ax
		sti
		pop	ds
		pop	ax
		ret

store8253	endp

restore8253	proc	near
		public	restore8253

		cmp	cs:mz_play, 0ffh
		jnz	@@1
		jmp	tinit
@@1:		push	ax
		mov	al, 34h
		out	43h, al
		mov	ax, 5950		; 23800
		out	40h, al
		mov	al, ah
		out	40h, al
		mov	al, 0b6h
		out	43h, al
		mov	ax, cs:_ctcset
		out	42h, al
		mov	al, ah
		out	42h, al
		push	ds
		xor	ax, ax
		mov	ds, ax
		cli
		mov	ax, offset main_8
		mov	ds:[8 * 4], ax
		mov	ax, cs
		mov	ds:[8 * 4 + 2], ax
		sti
		pop	ds
		pop	ax
		ret

restore8253	endp

init8253	proc	near
		public	init8253

		push	es
		push	di
		push	cx
		push	ax
		mov	ax, cs
		mov	es, ax
		mov	di, offset cntmode
		mov	cx, offset cnt2intr - offset cntmode
		mov	al, 0
		rep	stosb
		mov	cs: cnt_crs, 5
		mov	cs: crs_blk, 0
		mov	cs: cnt_33, 6
		mov	cs: frekv_33, 0
		mov	cs: jednou4, 0
		mov	cs: spkoff, 0
		mov	cs: _ctcakt + 4, 0ffffh
		mov	cs: frekvmotor, 1000
		mov	cs: cnt2intr, 0
		pop	ax
		pop	cx
		pop	di
		pop	es
		ret

init8253	endp

