		extrn	cfgMusic: byte
		extrn	data_8: word
		extrn	how_hrdwr: word
		extrn	scn_frekv: word

_setupCfg	proc
		public	_setupCfg

		push	bp
		mov	bp, sp
		les	bx, [bp + 6]
		mov	al, es:[bx]		; cfgDisk
		mov	cs:cfgDisk, al
		mov	al, es:[bx + 1]		; cfgMusic
		mov	cs:cfgMusic, al
		mov	ax, es:[bx + 2]		; cfgFreq
		mov	cs:data_8, ax
		mov	cs:scn_frekv, ax
;				bx + 4		; cfgRD	- pro strojak nev.
		mov	al, es:[bx + 5]
		dec	al
		mov	byte ptr cs:lpt_num, al
		mov	al, es:[bx + 7]		; how hardware
		mov	byte ptr cs:how_hrdwr, al		; + 1 !!!!
		mov	al, es:[bx + 9]		; only256 ?
		mov	cs:only_256, al
		mov	al, es:[bx + 10]	; VGA ?
		or	al, al
		mov	al, 10000b
		jz      @@1
		mov	al, 1000b
@@1:		mov	cs:vga_col, al
		pop	bp
		ret

_setupCfg	endp


prepXLAT	proc	near

		mov	bx, 0f000h	; pro prevod bitu
		xor	cx, cx
setMZ700_3:	mov	al, cl
		mov	dl, 0
		shr	al, 1
		rcl	dl, 1
		shr	al, 1
		rcl	dl, 1
		shr	al, 1
		rcl	dl, 1
		shr	al, 1
		rcl	dl, 1
		shr	al, 1
		rcl	dl, 1
		shr	al, 1
		rcl	dl, 1
		shr	al, 1
		rcl	dl, 1
		shr	al, 1
		rcl	dl, 1
		mov	es:[bx], dl
		inc	bx
		inc	cl
		jnz	setMZ700_3
		ret

prepXLAT	endp

; ===========================
;   set MZ-700
; ===========================

setMZ700	proc	near

		mov	cs:MODE, 0	; MZ - 700
		pusha
		call	prepXLAT
		popa
		mov	cs:MEMCFG, offset MAP700
		mov	cs:VMODE, 8
		ret

setMZ700	endp

tbl_modu	label

; MODE 0
		dw	2000h		; size
		db	4		; po co testovat (zapis)
		db	2		; po co testovat (cteni)
; MODE 1
		dw	2000h
		db	4
		db	2
; MODE 2
		dw	1000h
		db	10h
		db	4
; MODE 3
		dw	1		; NEPLATNY !!!
		db	2
		db	1
; MODE 4
		dw	4000h
		db	2
		db	1
; MODE 5
		dw	4000h
		db	2
		db	1
; MODE 6
		dw	2000h
		db	4
		db	2
; MODE 7
		dw	1		; NEPLATNY, ale co kdyby ...
		db	2
		db	1

prepVRAME	proc	near	; prepise video ram z pameti do EGy

		pusha
		mov	es, cs:seg_VRAM
		mov	ds, cs:seg_ROM
		mov     bl, cs:VMODE
		and	bx, 7
		shl	bx, 2
		add	bx, offset tbl_modu
		mov	dx, 3ceh
		mov	ax, 5 		; write mode
		out	dx, ax
		mov	ax, 3
		out	dx, ax
		mov	ax, 0
		out	dx, ax
		mov	ax, 1
		out	dx, ax
		mov	dx, 3c4h
		mov	cl, 1
		mov	si, 4000h	; zacatek VRAM
		cld
		cmp	cs:VMODE, 6	; specialni mod
		jz	@@2
@@1:		xor	di, di
		mov	ah, cl
		mov	al, 2
		out	dx, ax
		push	cx
		mov	cx, cs:[bx]	; velikost
		rep	movsw
		pop	cx
		shl	cl, 1		; vsechny desky
		cmp	cl, cs:[bx+2]
		jnz	@@1
		mov	es, cs:seg_ROM
		popa
		ret
@@2:		xor	di, di
		mov	ax, 102h
		out	dx, ax
		mov	cx, 2000h
		rep	movsw
		xor	di, di
		mov	ax, 402h
		out	dx, ax
		mov	cx, 2000h
		rep	movsw
		mov	es, cs:seg_ROM
		popa
		ret

prepVRAME	endp

prepVRAMR	proc	near

		pusha
		mov	ds, cs:seg_VRAM
		mov	es, cs:seg_ROM
		mov     bl, cs:VMODE
		and	bx, 7
		shl	bx, 2
		add	bx, offset tbl_modu
		mov	dx, 3ceh
		mov	ax, 405h		; read mode
		out	dx, ax
		mov	cl, 0
		mov	di, 4000h	; zacatek VRAM
		cld
		cmp	cs:VMODE, 6	; specialni mod
		jz	@@2
@@1:		xor	si, si
		mov	ah, cl
		mov	al, 4
		out	dx, ax
		push	cx
		mov	cx, cs:[bx]	; dve stranky
		cld
		rep	movsw
		pop	cx
		inc	cl		; vsechny desky
		cmp	cl, cs:[bx+3]
		jnz	@@1
		popa
		ret
@@2:		xor	si, si
		mov	ax, 4
		out	dx, ax
		mov	cx, 2000h
		rep	movsw
		xor	si, si
		mov	ax, 204h
		out	dx, ax
		mov	cx, 2000h
		rep	movsw
		popa
		ret

prepVRAMR	endp

; Vrati ukazatel v DX:AX na registr af, ktery je ulozen v pameti

_getSPointer	proc	far
		public	_getSPointer

		mov	dx, cs
		mov	ax, offset af
		ret

_getSPointer	endp

; ========================
;        reset
; ========================

reset		proc	near

		call	music_store		; vypni hudbu
		mov	cs:scroll_reg + 6, 0
		call	set_up_bor
		call	set_border		; smaz border
		push	ax
		mov	ax, cs
		mov	es, ax
		mov	di, offset af
		mov	cx, offset one_byte - offset af
		mov	al, 0
		rep	stosb
		mov	es, cs:seg_ROM
		call	setMZ700		; nastavi MZ-700 mod
		pop	ax
		cmp	al, 0ffh
		jz	@@1x
		call	prepareVGA
@@1x:		push	offset @@1
		push	bx
		jmp	out_e4			; jakoby to bylo...
@@1:		call	init8253
		call	restore8253
		call	kbd_init
		call	fdd_init
		call	initPIO
		call	video_init
		mov	cs:wvram_a, offset singleA
		mov	cs:rvram_a, offset readdirA
		mov	ax, cs
		mov	es, ax
		mov	ds, ax
		mov	di, offset one_byte
		mov	si, offset bas_instr
		mov	cx, 256
		cld
		rep	movsw
		mov	ds, cs:seg_RAM
		mov	es, cs:seg_ROM
		xor	ax, ax
		mov	cx, ax
		mov	dx, ax
		mov	si, ax
		mov	di, ax
		ret

reset		endp

; ====================
;      All init	  	(uint seg_RAM, uint seg_ROM)
; ====================

_allInit	proc	far
		public	_allInit

		push	bp
		mov	bp, sp
		mov	ax, [bp+10]
		mov	cs:rd_handle, ax
		mov	ax, [bp+8]
		mov	cs:seg_ROM, ax
		mov	ax, [bp+6]
		mov	cs:seg_RAM, ax
		push	si
		push	di
		push	es
		push	ds
		xor	ax, ax
		mov	ds, ax
		mov	ax, ds:[ 8 * 4 ]
		mov	cs:old_8, ax
		mov	ax, ds:[ 8 * 4 + 2 ]
		mov	cs:old_8 + 2, ax
		mov	al, 0ffh
		call	reset
		call	store8253
		pop	ds
		pop	es
		pop	di
		pop	si
		pop	bp
		ret

_allInit	endp

; ====================
;    prepare VGA
; ====================

prepareVGA	proc	near

		mov	cs:seg_VRAM, 0a000h
		mov	fs, cs:seg_VRAM
		cmp	cs:MODE, 0ffh		; MZ - 800 mod ?
		jnz	prepareVGA7
		jmp	prepareVGA8
prepareVGA7:	mov	ax, 1
		call	int_10
		mov	es, cs:seg_ROM
		mov	bp, 0d000h		; VRAM u sharpa
		mov	si, 4000h		; VRAM sharpa
		mov	cx, 400h
prepareVGA_0:	mov	bl, es:[si]
		call	WB7VRAMC			; zapis
		inc	bp
		inc	si
		loop	prepareVGA_0
		mov	bp, 0d800h		; VRAM u sharpa
		mov	si, 4800h		; VRAM sharpa
		mov	cx, 400h
prepareVGA_1:	mov	bl, es:[si]
		call	WB7VRAMC			; zapis
		inc	bp
		inc	si
		loop	prepareVGA_1
		ret
prepareVGA8:	mov	bh, cs:VMODE
		not	cs:VMODE		; uplne jiny mod ...
		push	offset @@90
		push	bx
		jmp	out_dmd			; zapis na display mode reg
@@90:		call	prepVRAME
		mov	dx, 3ceh
		mov	ax, 0
		out	dx, ax			; zasij enable/disable w ...
		inc	al
		out	dx, ax
		inc	al
		out	dx, ax
		inc	al
		out	dx, ax
		inc	al
		out	dx, ax
		inc	al
		out	dx, ax
		mov	bh, cs:wrtf
		not	cs:wrtf
		push	offset @@91
		push	bx
		jmp	out_wf
@@91:		mov	bh, cs:readf
		not	cs:readf
		push	offset @@92
		push	bx
		jmp	out_rf
@@92:		mov	bx, 4			; sw bit taky
@@93:		push	bx
		mov	bh, cs:[bx + offset pal4]
		push	bx
		mov	bh, 0
		not	cs:[bx + offset pal4]
		pop	bx
		push	offset @@94
		push	bx
		jmp	out_pal
@@94:		pop	bx
		dec	bl
		cmp	bl, 0ffh
		jnz	@@93
		mov	es, cs:seg_ROM
		call	prepXLAT
		call	set_border
		ret

prepareVGA	endp

; ====================
;     showSreen
; ====================

_showScreen	proc	far
		public	_showScreen

		push    ds
		push	es
		push	si
		push	di
		push	bp
		call	prepareVGA
		pop	bp
		pop	di
		pop	si
		pop	es
		pop	ds
		ret

_showScreen	endp

_showScrZX	proc	far
		public	_showScrZX

		push	ds
		push	es
		push	si
		push	di
		push	bp
		mov	ax, 0dh
		int	10h
		mov	es, cs:seg_ROM
		mov	ds, cs:seg_RAM
		call	set_colors
		call    prepZX
		pop	bp
		pop	di
		pop	si
		pop	es
		pop	ds
		ret

_showScrZX	endp

; ====================
;      restore
; ====================

restore		proc	near

		call	prepareVGA
		call	kbd_restore
		call	restore8253
		call	restoreFDD
		mov	fs, cs:seg_VRAM
		mov	ds, cs:seg_RAM
		mov	es, cs:seg_ROM
		mov	ax, cs:af
		mov	cx, cs:bc
		mov	dx, cs:de
		mov	di, cs:spx
		mov	si, cs:pcx
		ret

restore		endp

; =====================
;        store
; =====================

store		proc	near

		mov	cs:af, ax
		mov	cs:bc, cx
		mov	cs:de, dx
		mov	cs:spx, di
		mov	cs:pcx, si
		call	music_store	 ; vypni navzdy hudbu ...
		call	store8253
		call	kbd_store
		call	storeFDD
		cmp	cs:MODE, 0ffh
		jnz	@@1
		call	prepVRAMR
@@1:		mov	ax, 3		; Color 80x25
		int	10h
		ret

store		endp

; ====================
;       T r a p
; ====================

sch_ss		dw	0
sch_sp		dw	0

_trap		proc	far
		public	_trap

		pusha
		push	es
		push	ds
		mov	ax, cs
		mov	es, ax
		mov	di, offset one_byte
		mov	cx, 256
		mov	ax, offset _trap_e
		rep	stosw
		mov	word ptr cs:exit_ADR, ax
		mov	ax, cs
		mov	word ptr cs:exit_ADR+2, ax
		mov	cs:[sch_ss], ss
		mov	cs:[sch_sp], sp
		mov	cs:exit_Code, 0
		call	restore
		mov	bh, 0
		mov	bl, [si]
		shl	bx, 1
		jmp	word ptr [bx + offset bas_instr]
_trap_e:	cli
		mov	ss, cs:[sch_ss]
		mov	sp, cs:[sch_sp]
		sti
		cmp	cs:exit_CODE, 0		; break point ?
		jnz	_trap_e1		; pouze 0 neudela store
		call	store
_trap_e1:	pop	ds
		pop	es
		popa
		mov	ax, cs:exit_code
		ret

_trap		endp

; ==========================

prepareR	proc	near

		push	ds
		push	es
		push	cx
		push	di
		push	si
		push	ax
		mov	ax, cs
		mov	es, ax
		mov	ds, ax
		mov	di, offset one_byte
		mov	si, offset bas_instr
		mov	cx, 256
		cld
		rep	movsw
		pop	ax
		pop	si
		pop	di
		pop	cx
		pop	es
		pop	ds
		ret

prepareR	endp

; ====================
;       T r a c e
; ====================

breakpxx	db	0
breakpU		db	0
breakpadr	dw	0

_trace		proc	far
		public	_trace

		pusha
		push	es
		push	ds
		mov	ax, cs
		mov	es, ax
		mov	di, offset one_byte
		mov	cx, 256
		mov	ax, offset _trace_e
		rep	stosw
		mov	word ptr cs:exit_ADR, ax
		mov	ax, cs
		mov	word ptr cs:exit_ADR+2, ax
		mov	cs:[sch_ss], ss
		mov	cs:[sch_sp], sp
		mov	cs:exit_Code, 0
		call	restore
		mov	cs:breakpU, 0
		cmp	byte ptr [si], 0cdh
		jz	_trace_b
		cmp	byte ptr [si], 0c4h
		jz	_trace_b
		cmp	byte ptr [si], 0cch
		jz	_trace_b
		cmp	byte ptr [si], 0d4h
		jz	_trace_b
		cmp	byte ptr [si], 0dch
		jz	_trace_b
		cmp	byte ptr [si], 0e4h
		jz	_trace_b
		cmp	byte ptr [si], 0ech
		jz	_trace_b
		cmp	byte ptr [si], 0f4h
		jz	_trace_b
		cmp	byte ptr [si], 0fch
		jz	_trace_b
		jmp	_trace_1
_trace_b:	mov	cs:breakpU, 0ffh	; pouziju to
		mov	bl, [si+3]
		mov	cs:breakpxx, bl		; schovej byte pod tim
		mov	byte ptr [si+3], 6dh	; ld l, l
		mov	cs:breakpadr, si
		add	cs:breakpadr, 3
		call	prepareR
		jmp	_trace_go
_trace_1:       cmp	byte ptr [si], 0c7h
		jz	_trace_b1
		cmp	byte ptr [si], 0cfh
		jz	_trace_b1
		cmp	byte ptr [si], 0d7h
		jz	_trace_b1
		cmp	byte ptr [si], 0dfh
		jz	_trace_b1
		cmp	byte ptr [si], 0e7h
		jz	_trace_b1
		cmp	byte ptr [si], 0efh
		jz	_trace_b1
		cmp	byte ptr [si], 0f7h
		jz	_trace_b1
		cmp	byte ptr [si], 0ffh
		jz	_trace_b1
		jmp	_trace_go
_trace_b1:      mov	cs:breakpU, 0ffh
		mov	bl, [si+1]
		mov	cs:breakpxx, bl
		mov	byte ptr [si+1], 6dh
		mov	cs:breakpadr, si
		inc	cs:breakpadr
		call	prepareR
_trace_go:	mov	bh, 0
		mov	bl, [si]
		shl	bx, 1
		jmp	word ptr [bx + offset bas_instr]
_trace_e:	cli
		mov	ss, cs:[sch_ss]
		mov	sp, cs:[sch_sp]
		sti
		cmp	cs:exit_CODE, 0		; break point ?
		jnz	_trace_e1		; pouze 0 neudela store
		call	store
_trace_e1:	cmp	cs:breakpU, 0ffh
		jnz	_trace_e2
		mov	ds, cs:seg_RAM
		mov	al, cs:breakpxx
		mov	si, cs:breakpadr
		mov	[si], al		; vrat instrukci
		mov	ax, cs:pcx
		cmp	ax, cs:breakpadr
		jnz	_trace_e2
		mov	cs:exit_CODE, 0
_trace_e2:	pop	ds
		pop	es
		popa
		mov	ax, cs:exit_code
		ret

_trace		endp

; =============================
;   E m u l a t i o n   R U N
; =============================

xxbkp_set	db	0

_emu_run	proc	far
		public	_emu_run

		pusha
		push	es
		push	ds
		mov	cs:xxbkp_set, al
		mov	ax, cs
		mov	es, ax
		mov	ds, ax
		mov	di, offset one_byte
		mov	si, offset bas_instr
		mov	cx, 256
		cld
		rep	movsw
		mov	ax, offset _emu_run_e
		mov	word ptr cs:exit_ADR, ax
		mov	ax, cs
		mov	word ptr cs:exit_ADR+2, ax
		mov	cs:[sch_ss], ss
		mov	cs:[sch_sp], sp
		mov	cs:exit_Code, 0
		call	restore
		mov	bh, 0
		mov	bl, [si]
		cmp	cs:xxbkp_set, 0ffh
		jnz	@@1
		mov	byte ptr [si], 6dh	; LD L, L
@@1:		shl	bx, 1
		jmp	word ptr [bx + offset bas_instr]
_emu_run_e:	cli
		mov	ss, cs:[sch_ss]
		mov	sp, cs:[sch_sp]
		sti
		pop	ds
		pop	es
		popa
		mov	ax, cs:exit_code
		ret

_emu_run	endp

; =============================
;  Go to current cursor pos.
; =============================

adr_cur		dw	0
_old_byte	db	0

_gotoCursor	proc	far
		public	_gotoCursor

		pusha
		push	es
		push	ds
		mov	cs:adr_cur, AX
		mov	ax, cs
		mov	es, ax
		mov	ds, ax
		mov	di, offset one_byte
		mov	si, offset bas_instr
		mov	cx, 256
		cld
		rep	movsw
		mov	ax, offset _gotoCursor_e
		mov	word ptr cs:exit_ADR, ax
		mov	ax, cs
		mov	word ptr cs:exit_ADR+2, ax
		mov	cs:[sch_ss], ss
		mov	cs:[sch_sp], sp
		mov	cs:exit_Code, 0
		call	restore
		mov	bp, cs:adr_cur
		mov	bl, ds:[bp]
		mov	cs:_old_byte, bl
		mov	byte ptr ds:[bp], 6dh	; LD L, L
		mov	bh, 0
		cmp	si, bp
		jz	@@1
		mov	bl, [si]
@@1:		shl	bx, 1
		jmp	word ptr [bx + offset bas_instr]
_gotoCursor_e:	cli
		mov	ss, cs:[sch_ss]
		mov	sp, cs:[sch_sp]
		sti
		mov	si, cs:adr_cur
		mov	al, cs:_old_byte
		mov	ds:[si], al
		pop	ds
		pop	es
		popa
		mov	ax, cs:exit_code
		ret

_gotoCursor	endp

; ============================
;   All RAM on/off
; ============================

_switchRAM	proc    far
		public	_switchRAM

		pusha
		push	ds
		push	es
		cmp	al, 1		; off
		jz	@@1
		push	offset @@x1
		push	0
		jmp	out_e0
@@x1:		push	offset @@x2
		push	0
		jmp	out_e1
@@x2:		jmp	@@2
@@1:		push	offset @@x3
		push	0
		jmp	out_e2
@@x3:		push	offset @@x4
		push	0
		jmp	out_e3
@@x4:		push	offset @@x5
		push	0
		jmp	out_e4
@@x5:
@@2:		pop	es
		pop	ds
		popa
		ret

_switchRAM	endp
