; ====================================
;
;      emulace klavesnice SHARPA
;
; ====================================

		extrn	akt_vol_div: byte
		extrn	mz_play: byte

		EVEN

kbd_rad		dw	0
kbd_pom		db	0

		EVEN

w_kbd		proc	near

		pop	bx
		push	bx
		and	bx, 0fh		; cislo sloupce
		mov	cs:kbd_rad, bx
		pop	bx
		ret

w_kbd		endp

		EVEN

i_kbd		proc	near

		mov	bl, byte ptr cs:kbd_rad
		ret

i_kbd		endp

		EVEN

out_kbd		proc	near

		pop	bx
		push	bx
		mov	bl, bh
		and	bx, 0fh
		mov	cs:kbd_rad, bx
		pop	bx
		ret

out_kbd		endp

		EVEN

inp_kbd		label

r_kbd		proc	near

		mov	bx, cs:kbd_rad
		mov	bl, byte ptr cs:[bx + offset MATICE]
		ret

r_kbd		endp

		EVEN

extnd		db	0

		EVEN

main_9		proc

		cli
		push	ax
		push	cx
		in	al, 60h
		cmp	al, 0e0h
		jz	@@ke1
		cmp	al, 0
		jz	@@ke
		cmp	cs:extnd, 0ffh
		mov	cs:extnd, 0
		jnz	@@s
		jmp	@@kex
@@s:		mov	cl, al			; poznamenej
		and	al, 7fh			; orizni osmy bit
@@next:		cmp	al, 54h
		jnc	@@ke
		cmp	al, 1			; Esc ?
		jz	main_9_b
		push	bx
		mov	bx, offset key_tbl	; prevodni tabulka
		db	2eh			; cs:
		xlat
		cmp	al, 0ffh		; neprevadim ...
		jz	main_9_e
		mov	bl, al
		and	al, 0f0h
		cmp	al, 0f0h		; spec. klavesy ?
		jnz	@@nospec
		jmp	@@speckbd
@@nospec:	mov	al, bl
		and	bx, 0fh			; sloupec
		mov	ch, cs:[bx + offset BIT8]
		mov	bl, al
		shr	bl, 4			; radek
		test	cl, 80h
		jnz	main_9_1
		not	ch
		and	byte ptr cs:[bx + offset MATICE], ch
		jmp	main_9_2
main_9_1:       or	byte ptr cs:[bx + offset MATICE], ch
main_9_2:
main_9_e:	pop     bx
@@ke:		mov	al, 20h
		out	20h, al
		pop	cx
		pop	ax
		sti
		iret
@@ke1:		mov	cs:extnd, 0ffh
		jmp	@@ke
main_9_b:	push	es
		push	di
		push	cx
		mov	ax, cs
		mov	es, ax
		mov	di, offset one_byte
		mov	cx, 256
		mov	ax, offset kbd_break
		cld
		rep	stosw
		pop	cx
		pop	di
		pop	es
		mov	al, 20h
		out	20h, al
		pop	cx
		pop	ax
		sti
		iret
@@kex:		mov	cl, al
		and	al, 07fh
		cmp	al, 02ah	; koncim
		jz      @@ke
		jmp	@@next
@@speckbd:      test	cl, 80h
		jnz	main_9_e
		mov	cx, offset kbd_reset
		cmp	bl, 0feh	; reset ?
		jz	@@jmp_rut
		mov	cx, offset kbd_color
		cmp	bl, 0fdh	; zmena barev ?
		jz	@@jmp_rut
		mov	cx, offset swtch_snd
		cmp	bl, 0f9h	; sound switch
		jz	@@jmp_rut
		cmp	bl, 0fch	; sound off/on ?
		jz	@@sndon_off
		cmp	bl, 0fbh	; volume down
		jz	@@vol_down
		cmp	bl, 0fah	; volume up
		jz	@@vol_up
		jmp	main_9_e
@@jmp_rut:	push	es
		push	di
		mov	ax, cs
		mov	es, ax
		mov	di, offset one_byte
		mov	ax, cx
		mov	cx, 256
		cld
		rep	stosw
		pop	di
		pop	es
		mov	al, 20h
		out	20h, al
		pop	bx
		pop	cx
		pop	ax
		sti
		iret

@@sndon_off:	not	cs: SNDON
		jmp     main_9_e

@@vol_down:	inc	cs:akt_vol_div
		cmp	cs:akt_vol_div, 9
		jnz	@@vol_down1
		mov	cs:akt_vol_div, 8
@@vol_down1:	jmp	main_9_e

@@vol_up:	cmp	cs:akt_vol_div, 1
		jz	@@vol_up1
		dec	cs:akt_vol_div
@@vol_up1:	jmp	main_9_e

main_9		endp

kbd_break	proc	near

		mov	bx, 6
		jmp	error

kbd_break	endp

kbd_reset	proc	near

		mov	al, 0
		call	reset		; nastav vsechno znovu
kbd_reset_p:	mov	bh, 0
		mov	bl, [si]
		add	bx, bx
		jmp	word ptr cs:[bx + offset one_byte]

kbd_reset	endp

i_restore 	proc	near

		push	ds
		push	es
		push	si
		push	di
		push	ax
		push	cx
		mov	ax, cs
		mov	es, ax
		mov	ds, ax
		mov	di, offset one_byte
		mov	si, offset bas_instr
		mov	cx, 256
		cld
		rep	movsw
		pop	cx
		pop	ax
		pop	di
		pop	si
		pop	es
		pop	ds
		ret

i_restore	endp

kbd_color	proc	near

		call	i_restore
		cmp	cs:ptrCOLORS, offset COLORS	; barevne ?
		jnz	@@1
		mov	cs:ptrCOLORS, offset BWCOLORS
		mov	cs:ptrCOLORS7, offset BWCOLORS7
		jmp	@@2
@@1:		mov	cs:ptrCOLORS, offset COLORS
		mov	cs:ptrCOLORS7, offset COLORS7
@@2:		call	set_up_col
		call	set_border		; znovu nastav border
		jmp	kbd_reset_p

kbd_color	endp

swtch_snd	proc	near

		call	i_restore
		call	store8253
		not	cs: mz_play
		call	restore8253
		jmp	kbd_reset_p

swtch_snd	endp

; ==================================

		EVEN

MATICE		dw	8 dup (0ffffh)

		EVEN

BIT8		db	1, 2, 4, 8, 10h, 20h, 40h, 80h

		EVEN

; -----------------------------
;  kody klaves (scan)

key_tbl         db      0ffh                    ; ????          0
		db      0ffh                    ; Esc           1
		db      57h                     ; 1             2
		db      56h                     ; 2             3
		db      55h                     ; 3             4
		db      54h                     ; 4             5
		db      53h                     ; 5             6
		db      52h                     ; 6             7
		db      51h                     ; 7             8
		db      50h                     ; 8             9
		db      62h                     ; 9            0a
		db      63h                     ; 0            0b
		db      65h                     ; -            0c
		db      15h                     ; +            0d
		db      07h                     ; Bksp         0e
		db      03h                     ; Tab          0f
		db      27h                     ; Q            10
		db      21h                     ; W            11
		db      43h                     ; E            12
		db      26h                     ; R            13
		db      24h                     ; T            14
		db      17h                     ; Y            15
		db      23h                     ; U            16
		db      37h                     ; I            17
		db      31h                     ; O            18
		db      30h                     ; P            19
		db      14h                     ; [            1a
		db      13h                     ; ]            1b
		db      00h                     ; Enter        1c
		db      86h                     ; CTRL         1d
		db      47h                     ; A            1e
		db      25h                     ; S            1f
		db      44h                     ; D            20
		db      42h                     ; F            21
		db      41h                     ; G            22
		db      40h                     ; H            23
		db      36h                     ; J            24
		db      35h                     ; K            25
		db      34h                     ; L            26
		db      02h                     ; ;            27
		db      01h                     ; "            28
		db      06h                     ; `            29
		db      80h                     ; SHIFT (L)    2a
		db      67h                     ; \            2b
		db      16h                     ; Z            2c
		db      20h                     ; X            2d
		db      45h                     ; C            2e
		db      22h                     ; V            2f
		db      46h                     ; B            30
		db      32h                     ; N            31
		db      33h                     ; M            32
		db      61h                     ; ,            33
		db      60h                     ; .            34
		db      70h                     ; ?            35
		db      80h                     ; SHIFT (R)    36
		db      87h                     ; PrtSc        37
		db      04h                     ; Alt          38
		db      64h                     ; Space        39
		db      0ffh                    ; CAPS LOCK    3a
		db      97h, 96h, 95h, 94h, 93h ; F1 - F5
		db      0fdh                    ; F6 - barvy
		db	0fch			; F7 - sound on/off
		db	0f9h			; F8 - switch sound ...
		db	0ffh, 71h   		; F9 - F10
		db      0ffh                    ; NumLock      45
		db      0feh                    ; ScrollLock   46 - reset
		db      0ffh                    ; Home         47
		db      75h                     ; Up           48
		db      0fah                    ; PgUp         49 - volume
		db      0ffh                    ; Gray -       4a
		db      72h                     ; Left         4b
		db      0ffh                    ; Nic          4c
		db      73h                     ; Right        4d
		db      0ffh                    ; Gray +       4e
		db      0ffh                    ; End          4f
		db      74h                     ; Down         50
		db      0fbh                    ; PgDn         51 - volume
		db      77h                     ; Ins          52
		db      76h                     ; Del          53
		db      (80h - 53h) dup (0ffh)

; ===============================

old_9	  	dw	0, 0


kbd_restore	proc	near

		push	ax
		push	ds
		xor	ax, ax
		mov	ds, ax
		mov	ax, ds:[9 * 4]
		mov	cs:old_9, ax
		mov	ax, ds:[9 * 4 + 2]
		mov	cs:old_9 + 2, ax
		mov	ax, offset main_9
		mov	ds:[9 * 4], ax
		mov	ax, cs
		mov	ds:[9 * 4 + 2], ax
		pop	ds
		pop	ax
		jmp	kbd_init

kbd_restore	endp

kbd_store	proc	near

		push	ax
		push	ds
		xor	ax, ax
		mov	ds, ax
		mov	ax, cs:old_9
		mov	ds:[9 * 4], ax
		mov	ax, cs:old_9 + 2
		mov	ds:[9 * 4 + 2], ax
		pop	ds
		pop	ax
		ret

kbd_store	endp

kbd_init	proc	near

		push	es
		push	ax
		push	di
		mov	ax, cs
		mov	es, ax
		mov	di, offset MATICE
		mov	ax, 0ffffh
		stosw
		stosw
		stosw
		stosw
		stosw
		stosw
		stosw
		stosw
		pop	di
		pop	ax
		pop	es
		ret

kbd_init	endp

		public	key_wait

key_wait	proc	near

		push	cx
		push	bx
@@s:		mov	bx, offset MATICE
		mov	cx, 5
@@1:            cmp	cs:[bx], 0ffffh
		jnz	@@s
		add	bx, 2
		loop	@@1
@@s1:		mov	bx, offset MATICE
		mov	cx, 5
@@2:		cmp	cs:[bx], 0ffffh
		jnz	@@3
		add	bx, 2
		loop	@@2
		jmp	@@s1
@@3:		pop	bx
		pop	cx
		ret

key_wait	endp

		db	'hemoglobin ', 5, 15h
		db	20 * 4 dup (0)
		db	0, 0

