; ========================================
;
;       emulace RAM disku
;
; ========================================

		EVEN

rd_handle	dw	0ffffh

old_rdadr	db	0ffh
		EVEN
old_rdlow	db	0
old_rdhigh	db	0

new_rdadr	db	0
		EVEN
new_rdlow	db	0
new_rdhigh	db	0

rdflag		db	0		; 1 = je to treba ulozit

		EVEN

rdbuf		db	512 dup(0)

		EVEN

out_e9		proc	near

		pop	bx
		mov	cs:new_rdadr, bh	; v B je to
		and	cs:new_rdadr, 7		; jenom 3 bity (0-7)
		ret

out_e9		endp

		EVEN

inp_e9		proc	near

		ret

inp_e9		endp

		EVEN

out_eb		proc	near

		pop	bx
		mov	cs:new_rdhigh, ch
		mov	cs:new_rdlow, bh
		ret

out_eb		endp

inp_eb		proc	near

		ret

inp_eb		endp

		EVEN

nseek		proc	near

		cmp	cs:rd_handle, 0ffffh
		jnz	@@01
		ret
@@01:		pusha
		push	ds
		push	cs
		pop	ds
		cmp	cs:rdflag, 0		; jenom se cetlo ?
		jz	@@1
		mov	ax, 4200h		; seek from start
		mov	bx, cs:rd_handle
		mov	dx, word ptr cs:old_rdlow
		mov	cl, cs:old_rdadr
		mov	ch, 0
		int	21h
		mov	ah, 40h
		mov	bx, cs:rd_handle
		mov	dx, offset rdbuf
		mov	cx, 512
		int	21h
		mov	cs:rdflag, 0		; poznamenej konec
@@1:		mov	ax, word ptr cs:new_rdlow
		and	ax, 0fe00h		; 512 byte orez
		mov	word ptr cs:old_rdlow, ax
		mov	al, cs:new_rdadr
		mov	cs:old_rdadr, al
		mov	ax, 4200h		; seek from start
		mov	bx, cs:rd_handle
		mov	dx, word ptr cs:old_rdlow
		mov	cl, cs:old_rdadr
		mov	ch, 0
		int	21h
		mov	ah, 3fh
		mov	bx, cs:rd_handle
		mov	dx, offset rdbuf
		mov	cx, 512
		int	21h
		pop	ds
		popa
		ret

nseek		endp

		EVEN

inp_ea		proc	near

		mov	bl, cs:new_rdadr
		cmp	cs:old_rdadr, bl
		jnz	@@1
		mov	bx, word ptr cs:new_rdlow
		and	bx, 0fe00h		; 9 x bit = 512 byte cache
		cmp	word ptr cs:old_rdlow, bx
		jnz	@@1			; seek
		mov	bx, word ptr cs:new_rdlow
		and	bx, 1ffh
		mov	bl, cs:[bx + offset rdbuf]
		inc	word ptr cs:new_rdlow
		ret
@@1:		call	nseek
		mov	bx, word ptr cs:new_rdlow
		and	bx, 1ffh
		mov	bl, cs:[bx + offset rdbuf]
		inc	word ptr cs:new_rdlow
		ret

inp_ea		endp

		EVEN

out_ea		proc	near

		cmp	cs:rd_handle, 0ffffh
		jnz	@@01
		pop	bx
		ret
@@01:		pop	bx
		push	ax
		mov	al, bh
		mov	bl, cs:new_rdadr
		cmp	cs:old_rdadr, bl
		jnz	@@1
		mov	bx, word ptr cs:new_rdlow
		and	bx, 0fe00h		; 9 x bit = 512 byte cache
		cmp	word ptr cs:old_rdlow, bx
		jnz	@@1			; seek
		mov	bx, word ptr cs:new_rdlow
		and	bx, 1ffh
		mov	cs:[bx + offset rdbuf], al
		inc	word ptr cs:new_rdlow
		mov	cs:rdflag, 1
		pop	ax
		ret
@@1:		call	nseek
		mov	bx, word ptr cs:new_rdlow
		and	bx, 1ffh
		mov	cs:[bx + offset rdbuf], al
		inc	word ptr cs:new_rdlow
		mov	cs:rdflag, 1
		pop	ax
		ret

out_ea		endp

